#include <istream>
#include <vector>
#include <valarray>

using namespace std;

#ifndef __CUBICSPLINE_H
#define __CUBICSPLINE_H

class cubicspline {

    public:
    
        cubicspline();
        cubicspline(string inFilename);
        cubicspline(string inFilename, double inYp1, double inYpn);
        cubicspline(istream& inStream);

        ~cubicspline();

        void fromstream(istream& inStream);

        void attachFile(string inFilename);

        void            insertpoint(double inX, double inY);
        double          y(double inY);
        valarray<double>    y(valarray<double>& inY);

        double  dydx(double inY);
        double  d2ydx2(double inY);

        size_t  size()  { return mX.size(); }
        double  xelement(size_t i)  { return mX.at(i); }
        double  yelement(size_t i)  { return mY.at(i); }
        
        void    initSplineTables();
        void    clearTables();
        
    protected:

        vector<double>  mX; 
        vector<double>  mY; 

        vector<double> mY2; 

        bool    mInitialized;
        bool    mIsNatural;
        bool    mCacheEnabled;
        bool    mCacheInitialized;
                double  cX;
        double  cY;
                double  mYp1;
                double  mYpn;
};

#endif 
