/*******************************************************************************

   fourier.h    Function prototypes for fourier module 
   =========    see fourier.cp for more comments...

*******************************************************************************/



#ifdef __cplusplus  // Keep a C++ version
    #ifndef __FOURIER_CPP
        #define __FOURIER_CPP
        #include <math.h>
        #include <complex.h>
        #include <valarray>

        typedef std::complex<double> complex_double;
        typedef std::complex<float> complex_float;
        typedef double Double;
        
        char FFT(std::valarray<complex_double>& data, long isign);
        char FFT(std::valarray<complex_float>& data, long isign);
        char FFT2D_x(std::valarray<complex_double>& indata, long Nx, long Ny, long isign); 
        char FFT2D_y(std::valarray<complex_double>& indata, long Nx, long Ny, long isign); 
        char FFT2D(std::valarray<complex_double>& indata, long Nx, long Ny, long isign); 
        char ExtractFFTParams(std::valarray<double> inX, double& outdX, double & outXMax, double& outdF, double & outFmax);
//      void ShiftArrayElements(std::valarray<complex_double>& inArray, long inHowMany);

    #endif
#elif               // and a C version
    #ifndef __FOURIER_C
        #define __FOURIER_C
        #include <math.h>

        void FFT(double data[], long nn, long isign);
    #endif
#endif
