// Will do nothing if __MYDEBUG is not defined
#include "mydebug.h"
#include <complex>
#include <iostream>
#include <fstream>
#include <string>

using namespace std;


/*
 * Physical constants
 */
 
const double pi = 3.141592653589793238462643383279;     // Some constant
const double c                  = 3e8;                                  // Speed of light m/s
const long TOLERANCE            = 10;                                   // We tolerate an error of TOLERANCE * epsilon
const double epsilon_o          = 8.82e-12;                             // Permittivity
const Complex I = Complex(0.,1.);

/*
 * Program helper
 */
 
#define SQR(x)  ((x)*(x))
#define CUBE(x) ((x)*(x)*(x))

/*
 * Parameter calculation (proper sign for imaginary part)
 */

 Complex            epsilon (   double n, 
                                double k) ;

 Complex            index   (   Complex epsilon) ;
 Complex            w       (   double inOmega, 
                                double inK,
                                Complex epsilon );

/* 
 * Fresnel coefficients
 */

 Complex rpij(  double Omega, double K,
                Complex ei, Complex ej);
 Complex tpij(  double Omega, double K,
                Complex ei, Complex ej);
 Complex rsij(  double Omega, double K,
                Complex ei, Complex ej);
 Complex tsij(  double Omega, double K,
                Complex ei, Complex ej);


/*
 * EO Filter function
 */
void eofilter(double l, double ng, string file, string s1, string s2);

